# Ваш перший Django проект!

> Частина цього розділу базується на матеріалах Geek Girls Carrots (http://django.carrots.pl/).
> 
> Частина цього розділу базується на матеріалх [django-marcador tutorial][1] ліцензованих Creative Commons Attribution-ShareAlike 4.0 International License. Авторське право на навчальні матеріали django-marcador tutorial належить Markus Zapke-Gründemann та ін.

 [1]: http://django-marcador.keimlink.de/

Ми збираємося створити простий блог!

Перший крок це створити новий Django проект. В основному, це означає що ми будемо запускати певні скрипти Django, які створюватимуть для нас каркас Django проекту: набір папок і файлів, які ми будемо пізніше використовувати.

Імена деяких файлів і папок є дуже важливими для Django. Не можна перейменовувати файли, які ми зараз будемо створювати. Їх переміщення в різні місця також не є хорошою ідеєю. Django потребує підтримки певної структури, для того щоб бути в змозі знаходити важливі речі.

В консолі потрібно запустити (пам'ятайте, що не треба набирати `(myvenv) ~/djangogirls$`, OK?):

> Пам'ятайте, що усе треба запускати у віртуальному середовищі. Якщо ви не бачите префікс `(myvenv)` в консолі, то потрібно активувати ваше віртуальне середовище. Ми пояснювали як це зробити у розділі **Встановлення Django** в частині **Робота з віртуальним середовищем**.

Запустіть:

    django-admin startproject mysite .

для Windows:

    (myvenv) C:\Users\Name\djangogirls> python myvenv\Scripts\django-admin.py startproject mysite .


> **Зауваження** Переконайтесь, що ви включили (`.`) вкінці команди, це важливо.

`django-admin.py` - це скрипт, що створить для вас усі необхідні папки і файли. Наразі ви повинні мати структуру, котра виглядає наступним чином:

    djangogirls
    ├───manage.py
    └───mysite
            settings.py
            urls.py
            wsgi.py
            __init__.py
    

`manage.py` - скрипт, що допомагає керувати сайтом. З його допомогою ми зможемо запускати веб сервер без встановлення чогось іще додатково, серед іншого.

Файл `settings.py` містить конфігурацію вашого веб сайту.

Пам'ятаєте, коли ми розмовляли про листоношу, що перевіряє куди треба доправити листа? Файл `urls.py` містить список шаблонів, що використовуються елементом `urlresolver`.

Проігноруємо поки інші файли, адже ми не будемо їх змінювати. Єдина річ, яку варто пам'ятати - не видалити їх ненароком!

## Зміна налаштувань

Здійснимо деякі зміни в `mysite/settings.py`. Відкриємо файл в текстовому редакторі, який ви мали встановити раніше.

Було б добре мати коректні часові налаштування на нашому веб сайті. Перейдіть на http://en.wikipedia.org/wiki/List_of_tz_database_time_zones і скопіюйте відповідний часовий пояс (TZ). (наприклад, `Europe/Berlin` )

Потрібно знайти рядок, що містить `USE_TZ` і `TIME_ZONE` та модифікувати їх, щоб вони мали наступний вигляд, підставляючи замість `Europe/Berlin` відповідно ваш часовий пояс:

    USE_TZ = False
    TIME_ZONE = 'Europe/Berlin'
    

## Налаштування бази даних

Існує безліч різноманітних програмних продуктів, що працюють із базами даних і можуть зберігати дані для вашого сайту. Ми будемо користуватися таким, що вказаний за замовчуванням - `sqlite3`.

Відповідні налаштування вже прописані у файлі `mysite/settings.py`:

    DATABASES = {
        'default': {
            'ENGINE': 'django.db.backends.sqlite3',
            'NAME': os.path.join(BASE_DIR, 'db.sqlite3'),
        }
    }
    

Щоб створити базу даних для нашого блогу, давайте запустимо наступне в консолі: `python manage.py migrate` (ми повинні знаходитися всередині директорії `djangogirls`, яка містить файл `manage.py`). Якщо все пройшло успішно, ви маєте побачити щось на кшталт:

    (myvenv) ~/djangogirls$ python manage.py migrate
    Operations to perform:
      Apply all migrations: admin, contenttypes, auth, sessions
    Running migrations:
      Applying contenttypes.0001_initial... OK
      Applying auth.0001_initial... OK
      Applying admin.0001_initial... OK
      Applying sessions.0001_initial... OK
    

Ми це зробили! Час запустити веб сервер і перевірити чи працює наш сайт!

Ви повинні знаходитися в папці, що містить файл `manage.py` (папка `djangogirls`). В консолі ми можемо активувати веб сервер запустивши `python manage.py runserver`:

    (myvenv) ~/djangogirls$ python manage.py runserver
    

А зараз все, що ви повинні перевірити це чи активований ваш веб сайт. Відкрийте ваш браузер (Firefox, Chrome, Safari, Internet Explorer або будь-який, який ви використовуєте) і введіть адресу:

    http://127.0.0.1:8000/
    

Веб сервер буде приймати команду із командного рядка поки ви не зупините її: щоб набрати нову команду відкрийте нове вікно терміналу (і не забудьте всередині цього вікна також активувати ваше віртуальне середовище), або ж зупиніть веб сервер повернувшись до вікна, в котрому він запущений і натиснувши CTRL+C - клавіші Control і C buttons разом (одночасно) (на Windows, ви можете натиснути Ctrl+Break).

Вітаємо! Ви щойно створили ваш перший веб сайт і запустили його використовуючи веб сервер! Хіба ж це не круто?

![It worked!](images/it_worked2.png)

Готові до наступного кроку? Час створити певний контент!
